package cooper

import (
	"errors"
	"net/url"
)

//灯路配置添加
func (that *CooperClient) NewUsrK3LightModAddRequest() *UsrK3LightModAddRequest {
	return &UsrK3LightModAddRequest{
		Request: Request{
			Client:     that,
			apiAddress: "/usrK3/lightModAdd",
		},
	}
}

//UsrK3LightModAddRequest ...
type UsrK3LightModAddRequest struct {
	Request
}

//设备ID
func (that *UsrK3LightModAddRequest) SetDevId(value string) *UsrK3LightModAddRequest {
	that.initParams()
	that.params.Set("dev_id", value)
	return that
}

//开关模块名称
func (that *UsrK3LightModAddRequest) SetModName(value string) *UsrK3LightModAddRequest {
	that.initParams()
	that.params.Set("mod_name", value)
	return that
}

//设备拨片编号
func (that *UsrK3LightModAddRequest) SetModSort(value int64) *UsrK3LightModAddRequest {
	that.initParams()
	that.params.Set("mod_sort", ToString(value))
	return that
}

//设备类型
func (that *UsrK3LightModAddRequest) SetModType(value int64) *UsrK3LightModAddRequest {
	that.initParams()
	that.params.Set("mod_type", ToString(value))
	return that
}

//Params ...
func (that *UsrK3LightModAddRequest) Params() (url.Values, error) {
	that.initParams()
	_params := that.params
	if that.publicParamsSlice != nil {
		for _, _v := range that.publicParamsSlice {
			if _params.Get(_v) == "" {
				return nil, errors.New(that.apiAddress + "缺少参数:" + _v)
			}
		}
	}
	return _params, nil
}

//Do ...
func (that *UsrK3LightModAddRequest) Do() (interface{}, error) {
	//返回data
	_data, _err := that.Client.Post(that.apiAddress, that)
	if _err != nil {
		return nil, _err
	}
	return _data, nil
}
